#pragma once

#include <string>
#include <list>

#include "vdef.h"

namespace vCommon
{

//-----------------------------------------------------------------------------
//
    enum class WordOrder
    {
        big_endian
        , little_endian
        , mid_big_endian
        , mid_little_endian
    };

	class net
	{
	public:
        static byte re_buf [ sizeof ( u64 ) ];

		//	buf <= u16
		static void set_16 ( byte* buf, int& offset, u16 value, WordOrder wo = WordOrder::big_endian );

		//	buf <= u32
		static void set_32 ( byte* buf, int& offset, u32 value, WordOrder wo = WordOrder::big_endian );

		//	buf => i16
		static i16 get_i16 ( byte* buf, int& offset, WordOrder wo = WordOrder::big_endian );

		//	buf => u16
		static u16 get_u16 ( byte* buf, int& offset, WordOrder wo = WordOrder::big_endian );

        //  buf => i32
        static i32 get_i32 ( byte* buf, int& offset, WordOrder wo = WordOrder::big_endian );

        //  buf => u32
        static u32 get_u32 ( byte* buf, int& offset, WordOrder wo = WordOrder::big_endian );

        //  buf => i32
        static i64 get_i64 ( byte* buf, int& offset, WordOrder wo = WordOrder::big_endian );

        //  buf => u32
        static u64 get_u64 ( byte* buf, int& offset, WordOrder wo = WordOrder::big_endian );

        //  buf => f32
        static float get_f32 ( byte* buf, int& offset, WordOrder wo = WordOrder::big_endian );

		//	copy
		static void copy ( byte* dst, int& dst_offset, byte* src, int src_offset, int src_size );

		//	list <= 8
		static void set_8 ( std::list<byte>& buf, byte value );

		//	list <= 16
		static void set_16 ( std::list<byte>& buf, u16 value );

		//	list <= u32
		static void set_32 ( std::list<byte>& buf, u32 value );

		//	list <= string
		static void set_string ( std::list<byte>& buf, std::string& value );

		//	copy
		static void copy ( std::list<byte>& src, std::list<byte>& dst );

		//	copy
		static void copy ( std::list<byte>& src, byte* dst, int bsize );

		//  reorder buf
		static void reorder_buf ( byte* src, int src_size, int& offset, byte* dst, int dst_size, WordOrder wo, int type_size );
	};

} /* namespace vCommon */
