#pragma once

#include <string>

#include "DateTime.h"

namespace vCommon
{
	/*
	 Значение	Диапазон	Дополнительно
	 минуты		0-59
	 часы		0-23
	 дни месяца	1-31
	 месяцы		1-12		можно задавать и в 3-х буквенном варианте
	 дни недели	0-6			можно задавать и в 3-х буквенном варианте (0=воскресенье)

	 Символ '*' подразумевает - любое значение.

	 Минимальное время одна минута.

	 Дни недели и месяца в трех буквенном варианте:
	 sun mon tue wed thu fri sat
	 jan feb mar apr may jun jul aug sep oct nov dec
	 */

	static const std::string c_Reboot ( "@reboot" );
	static const std::string c_Holiday ( "h" );
	static const std::string c_Work ( "w" );
	static const int VectorSize ( 5 );
	//
	//	Парсер строки cron-формата
	//
	class vCron
	{
	private:
		//	заполнить элемент
		void FillItem ( std::string& item, int min, int beg, int end, int Step );
		//	распарсить токен
		std::string ParseToken ( const std::string& token, int min, int max );
		//	распарсить cубтокен
		void ParseSubtoken ( std::string& item, const std::string& subtoken, int min, int max, int Step );

	public:

		std::string min;
		std::string hour;
		std::string day;
		std::string month;
		std::string wday;
		bool IsReboot;
		bool IsHoliday;
		bool IsWorkday;

		//	ctor
		vCron ( const std::string& cron );
		//	Compare
		bool Compare ( const vCommon::DateTime& dt );
		//	ToString
		std::string ToString ( );
	};

} /* namespace vCommon */
